#ifndef ANALYZEDIALOG_H_
#define ANALYZEDIALOG_H_

#include "dialog.h"
#include "project.h"
#include "group.h"
#include "video.h"
#include "audio.h"
#include "subtitle.h"
#include "string.h"

#include <vector>

class AnalyzeDialog : public Dialog
{
public:
	AnalyzeDialog();
	virtual ~AnalyzeDialog();
	void AddProject(ProjectPtr project);
	void AddVideo(VideoPtr video);
	void AddAudio(AudioPtr audio);
	void AddSubtitle(SubtitlePtr subtitle);
	bool DoModal(Dialog * dialog);
	int GetCount();
	VideoPtr GetVideo(int index);
	AudioPtr GetAudio(int index);
	SubtitlePtr GetSubtitle(int index);

protected:
	bool DialogProc(UINT message, WPARAM wParam, LPARAM lParam);
	bool DoAnalyze();
	
	struct StuffToAnalyze {
		GroupPtr m_Group;
		VideoPtr m_Video;
		AudioPtr m_Audio;
		SubtitlePtr m_Subtitle;
	};
	std::vector<StuffToAnalyze> m_StuffToAnalyze;
};

#endif // ANALYZEDIALOG_H_
