#ifndef DIALOG_H_
#define DIALOG_H_

#include <windows.h>

class Dialog
{
public:
	Dialog();
	virtual ~Dialog();

protected:
	bool Create(HINSTANCE hInstance, LPCTSTR lpTemplate, HWND hWndParent);
	int DoModal(HINSTANCE hInstance, LPCTSTR lpTemplate, HWND hWndParent);

protected:
	virtual bool DialogProc(UINT message, WPARAM wParam, LPARAM lParam) = 0;

private:
	HWND m_hWnd;
	bool m_IsModal;
	Dialog * m_PrevDialog;
public:
	HWND hWnd() { return m_hWnd; };
	bool IsModal() { return m_IsModal; };
	static Dialog * GetActDialog();
	virtual void Refresh();

private:
	static BOOL CALLBACK _DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	static Dialog * s_ActDialog;
};

#endif // DIALOG_H_
