#include "isomaker.h"
#include "project.h"
#include "tools.h"
#include "winutils/winutils.h"

ISOMaker::ISOMaker(ProjectPtr project) : Thread()
{
	m_Project = project;
}

ISOMaker::~ISOMaker()
{
}

String ISOMaker::GetDescription() const
{
	return S("Creating ISO image");
}

bool ISOMaker::OnRun()
{
	bool ok = true;
	
	String mkisofsCommand = S("-dvd-video -o ")
		+ String(m_Project->GetOutputDirectory() + S("\\") + m_Project->GetOutputDirectory().toFileName() + S(".iso")).enclose()
		+ S(" ") + String(m_Project->GetOutputDirectory() + S("\\DVD")).enclose();
	String logFileName = String(m_Project->GetOutputDirectory() + S("\\") + S("log.txt")).toFullPath();

	ok = ok && ExecuteCommand(tools.mkisofs.c_str(), mkisofsCommand.c_str(), 
		NULL, NULL, logFileName.c_str(), isCancelled, waitingForUser);

	if (ok) DeleteFilesNow();
	return ok;
}

