#ifndef LOOKATVIDEODIALOG_H_
#define LOOKATVIDEODIALOG_H_

#include "dialog.h"
#include "avswrapper.h"
#include "string.h"

#define FRAME_COUNT 100

class LookAtVideoDialog : public Dialog 
{
public:
	LookAtVideoDialog(Dialog * parent, const String & fileName, const String & opener, bool upsideDown, const String & preProcessor, bool pal);
	virtual ~LookAtVideoDialog();

public:
	int DoModal();

protected:
	bool DialogProc(UINT message, WPARAM wParam, LPARAM lParam);

public:
	LRESULT ViewFrameProc(HWND vfWnd, UINT message, WPARAM wParam, LPARAM lParam);

protected:
	Dialog * m_Parent;
	String m_FileName;
	String m_Opener;
	bool   m_UpsideDown;
	String m_PreProcessor;
	bool   m_PAL;
	AVSWrapper m_AVS;
	int m_FirstFrame;
	int m_LastFrame;
	HBITMAP m_FullBitmap[FRAME_COUNT];
	bool m_HalfFrames;
};

VOID RegisterLookAtVideoDialogControls();

#endif // #define LOOKATVIDEODIALOG_H_