#include "main.h"
#include "tools.h"
#include "config.h"
#include "maindialog.h"
#include "menudialog.h"
#include "lookatvideodialog.h"
#include "string.h"

#include <objbase.h>

HINSTANCE hInstance;
Config * g_Config;
int g_IsAnalyzing;

int WINAPI WinMain(HINSTANCE instance, HINSTANCE prevInstance, LPSTR cmdLine, int cmdShow)
{
	hInstance = instance;
	CoInitialize(NULL);
	InitializeTools();
	RegisterMenuDialogControls();
	RegisterLookAtVideoDialogControls();

	bool checkAviSynthOnly = false;
	String projectToOpen;
	int argc;
	LPWSTR * argv = CommandLineToArgvW(GetCommandLine(), & argc);
	if (argv && (argc > 1)) {
		if (! lstrcmpi(argv[1], TEXT("/CHECKAVISYNTH"))) {
			checkAviSynthOnly = true;
		} else if (argv[1][0] != TEXT('/')) {
			projectToOpen = argv[1];
		}
	}
	LocalFree((HLOCAL) argv);

	g_Config = NULL;
	g_IsAnalyzing = 0;
	
	MainDialog mainDialog(projectToOpen, checkAviSynthOnly);
	mainDialog.DoModal();

	delete g_Config;

	return 0;
}
