#ifndef MENUDIALOG_H_
#define MENUDIALOG_H_

#include "dialog.h"
#include "maindialog.h"
#include "menu.h"

class MenuDialog : public Dialog
{
public:
	MenuDialog(MainDialog * mainDialog, MenuPtr menu, int groupIndex);
	virtual ~MenuDialog();

public:
	int DoModal();

protected:
	void UpdateBitmap();
	void Update(bool reset = false);
	bool DialogProc(UINT message, WPARAM wParam, LPARAM lParam);
	void InitDialog();
	void MeasureItem(LPMEASUREITEMSTRUCT mis);
	void DrawItem(LPDRAWITEMSTRUCT dis);
	void OnSelChange();
	void BrowseBackgroundImage();
	void ChooseMenuColor(int which);

public:
	LRESULT PreviewWndProc(HWND previewWnd, UINT message, WPARAM wParam, LPARAM lParam);
	
protected:
	MainDialog * m_MainDialog;
	MenuPtr m_Menu;
	int m_GroupIndex;
	HBITMAP m_Bitmap;
	RECT m_ImageRect;
	int m_DragOp;
	bool m_IsDragging;
	bool m_ReallyDragging;
	POINT m_DragOrigin;
	std::vector<POINT> m_OrigXY;
};

LRESULT CALLBACK MenuColorControlProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK MenuPreviewControlProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void RegisterMenuDialogControls();

#endif // MENUDIALOG_H_
