#ifndef MENUDRAWER_H_
#define MENUDRAWER_H_

#include "thread.h"
#include "project.h"

class MenuDrawer : public Thread
{
public:
	MenuDrawer(ProjectPtr project, int groupIndex, int whichMenu);
	virtual ~MenuDrawer();
	String GetDescription() const;
public:
	static void DrawMenuItems(Menu * menu, HDC dc, int xoffset, int yoffset, 
		bool preview = true, COLORREF bgColor = 0, COLORREF fgColor = 0, 
		bool highlighted = false, bool dragBoxes = false);
protected:
	bool Draw(Menu * menu, COLORREF bgColor, int menuColor, const String & fileName, LPRECT videoRect);
	bool OnRun();
	ProjectPtr m_Project;
	int m_GroupIndex;
	int m_WhichMenu;
};

#endif // MENUDRAWER_H_
