#ifndef SUBTITLEENTRY_H_
#define SUBTITLEENTRY_H_

#include "string.h"
#include "managableptr.h"
#include "managedptr.h"

#include <vector>

#include <windows.h>

class SubtitleEntry : public ManagablePtr
{
public:
	SubtitleEntry();
	virtual ~SubtitleEntry();

	bool operator < (const SubtitleEntry & entry) const;

	void AppendLine(const String & line);
	void AppendLines(const SubtitleEntry & entry);
	void BreakLongestLine();
	int GetLineCount() const;
	String GetLine(int index) const;

	void SetStartTime(double startTime);
	void SetEndTime(double endTime);
	double GetStartTime() const;
	double GetEndTime() const;
	String GetFormattedStartTime() const;
	String GetFormattedEndTime() const;

protected:
	double m_StartTime;
	double m_EndTime;
	StringVector m_Lines;
};

typedef ManagedPtr<SubtitleEntry> SubtitleEntryPtr;
typedef std::vector<SubtitleEntryPtr> SubtitleEntryVector;

#endif // SUBTITLEENTRY_H_
